Bug 133502 - up2date doesn't seem to validate RootCA of custom yum repository over https
up2date doesn't seem to validate RootCA of custom yum repository over https
Status: CLOSED WONTFIX
Product: Red Hat Enterprise Linux 3
Classification: Red Hat
Component: up2date (Show other bugs)
3.0
All Linux
medium Severity medium
: ---
: ---
Assigned To: Bret McMillan
Fanny Augustin
: FutureFeature
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2004-09-24 11:20 EDT by Chris Stankaitis
Modified: 2007-11-30 17:07 EST (History)
0 users

See Also:
Fixed In Version:
Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2007-10-19 15:17:43 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Chris Stankaitis 2004-09-24 11:20:54 EDT
Description of problem:

I created a custom yum repository, to keep things secure I am running
it over SSL using a signed cert from our Company Root-CA.  On box I
have added the repository to the /etc/sysconfig/rhn/sources and the
Root CA to the /usr/share/rhn/RHNS-CA-CERT and all seemed good. I
tested up2date on a box where I had NOT added the rootca to the
/usr/share/rhn/RHNS-CA-CERT file and it also worked with no visible
erros to screen or to logs about it being unable to validate the cert
on my https reopsitory.

Version-Release number of selected component (if applicable):

up2date-4.2.38-1

How reproducible:

Always

Steps to Reproduce:
1. add repository yum dw-custom https://URL-TO-REPO to rhn/sources
2. do NOT add RootCA to RHNS-CA-CERT
3. up2date -l; up2date -u pkgname
  
Actual results:

up2date pulls headers/installs packages without complaining that it
cannot verify the SSL cert

Expected results:

some error to screen/log that it can not verify the SSL Cert due to a
missing CA and then exit
Comment 1 Chris Stankaitis 2004-10-20 12:45:51 EDT
Almost a month with no comment from RH, can I please get an update?
Comment 2 Chris Stankaitis 2004-12-02 12:37:20 EST
2 month no comments. this is a potential security issue as it would
appear that there is no validation of the RootCA
Comment 3 Adrian Likins 2004-12-02 17:09:37 EST
CA certs are only verified for rhn repos (aka, default
configs). Any other repos use http or unverified https. 
Comment 4 Chris Stankaitis 2004-12-06 15:48:27 EST
escalating this bug as a security concern, with up2date running
unverified https it opens repo's up to being hijacked and having
arbatraty/malicious packages installed on users machines.

I can list many scenarios where this can be exploited under the right
circumstances.

please correct this issue and add rootCA verification for up2date to
ensure the validity of the SSL connection for Repo's other then RHN.
Comment 5 Josh Bressers 2004-12-07 16:01:32 EST
I'm removing the security severity on this issue.  Trusting up2date to
verify a connection is not secure.  The reason package are GPG signed
is to ensure that no matter the transport layer, the package is from
who you think it's from.

If you place complete trust in your yum repository, even though you
have a valid SSL cert, the server could be compromised and malicious
packages placed on it.  Trusting the GPG package signatures ensures
this is not a problem.
Comment 6 Chris Stankaitis 2004-12-07 16:20:58 EST
This is not an issue for me, we do GPG sign all our RPM's but I would
worry a lot of people out there with custom repo's would not be going
to the same length using GPG, and configuring up2date to use the
--nosig option(the UseGPG option in up2date --configure) and ignore
GPG trusting in SSL which they might believe is validated.  

It's inconsistant behaviour, up2date will validate the RHN Cert and
refuse to work if it can not validate that cert, one would presume
(incorrectly) that if it validates the RHN cert that ssl cert
validation would be a default behaviour for the program.

I'll switch this to an RFE, I still consider this issue something
which should be looked into.
Comment 7 RHEL Product and Program Management 2007-10-19 15:17:43 EDT
This bug is filed against RHEL 3, which is in maintenance phase.
During the maintenance phase, only security errata and select mission
critical bug fixes will be released for enterprise products. Since
this bug does not meet that criteria, it is now being closed.
 
For more information of the RHEL errata support policy, please visit:
http://www.redhat.com/security/updates/errata/
 
If you feel this bug is indeed mission critical, please contact your
support representative. You may be asked to provide detailed
information on how this bug is affecting you.

Note You need to log in before you can comment on or make changes to this bug.